﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	
	Public RealBlockWidth As Double
	Public RealLeft As Double
	
	Dim Rows As List
	
	Public ActiveRowID As Int = 0
	Public ActiveCellID As Int = 0	
	Dim ABC As ABCanvas
	Dim LastMouseCursor As String = "DEFAULT"
	
	Public IsDragging As Boolean
	Public IsResizing As Boolean
	Public StartDragX As Int
	
	Public ActiveGridType As Int = 0
	Public RealLastMaxHeight As Int = 10000	
	
	Public GridCanvas As Canvas
	Public PCanvas As Canvas
	Public TCanvas As Canvas
	Public DCanvas As Canvas	
	
	Private ABM As ABMaterial 'ignore
	
	Public IsPage As Boolean
End Sub

public Sub ActiveRow() As GridBuilderRect
	Return Rows.Get(ActiveRowID)
End Sub

public Sub ActiveCell(GridType As Int) As GridBuilderRect
	Dim r As GridBuilderRect = Rows.Get(ActiveRowID)
	
	If ActiveCellID >= r.Cells(ActiveGridType).Size Then
		ActiveCellID = r.Cells(ActiveGridType).Size - 1
	End If
	Return r.Cells(GridType).Get(ActiveCellID)
End Sub

Public Sub Initialize(c1 As Canvas, c2 As Canvas , c3 As Canvas, c4 As Canvas, asPage As Boolean )
	IsPage = asPage
	Rows.Initialize
	Rows.Clear
	AddRow	
	GridCanvas = c1	
	PCanvas = c2
	TCanvas = c3
	DCanvas = c4		
End Sub

public Sub SetMouseCursor(c As Canvas, mouseType As String)
	If mouseType = LastMouseCursor Then Return
	Dim cursor As JavaObject
	cursor.InitializeStatic("javafx.scene.Cursor")   
	Dim joObj As JavaObject = c
	
	joObj.RunMethod("setCursor", Array(cursor.GetField(mouseType)))
	
	LastMouseCursor = mouseType
End Sub

public Sub Draw(CheckRow As Int, CheckCell As Int, WithMinis As Boolean)
	If GridCanvas.IsInitialized = False Then Return
	
	If WithMinis Then
		DrawInternal(PCanvas, CheckRow, CheckCell, 0, True)
		DrawInternal(TCanvas, CheckRow, CheckCell, 1, True)
		DrawInternal(DCanvas, CheckRow, CheckCell, 2, True)
	End If
	DrawInternal(GridCanvas, CheckRow, CheckCell, ActiveGridType, False)
End Sub

public Sub DrawInternal(c As Canvas, CheckRow As Int, CheckCell As Int, DrawGridType As Int, IsMini As Boolean)
	Dim Spacing As Double
	Dim Top As Double = 5
	Dim Left As Double
	Dim GridWidth As Double
	Dim BlockWidth As Double
	Dim LastMaxHeight As Double
	Dim Scale As Double = 1.0
	GridWidth = c.PrefWidth-20
	If GridWidth < 1000 Then
		Left = (GridWidth)/20
		BlockWidth = (GridWidth - Left*2) / 12
		Spacing = 15 
	Else
		Left = (GridWidth-900)/2
		BlockWidth = 900 / 12
		Spacing = 15 
		GridWidth = 900
	End If
	
	If IsMini = False Then		
		RealLeft = Left
		RealBlockWidth = BlockWidth
		LastMaxHeight = RealLastMaxHeight
	Else
		Scale = 0.1
		LastMaxHeight = 1000
		Spacing = 2
		Left = 15	
		Select Case DrawGridType
			Case 0
				BlockWidth = BlockWidth * 0.5
				Left = 38
			Case 1	
				BlockWidth = BlockWidth * 0.75
				Left = 28
		End Select
	End If
	
	If DesTheme.DarkTheme Then
		c.DrawRect(0,0,c.Width, LastMaxHeight, fx.Colors.RGB(64,64,64),True, 0)
		For i = 0 To 11
			c.DrawRect((Left + i*BlockWidth),0,(BlockWidth-Spacing), LastMaxHeight, fx.Colors.RGB(72,72,72), True, 0)
		Next		
	Else
		c.DrawRect(0,0,c.Width, LastMaxHeight, fx.Colors.RGB(244,244,244),True, 0)
		For i = 0 To 11
			c.DrawRect((Left + i*BlockWidth),0,(BlockWidth-Spacing), LastMaxHeight, fx.Colors.RGB(250,250,250), True, 0)
		Next		
	End If
	
	Dim LastRowTop As Double = Top
	
	For i = 0 To Rows.Size - 1		
		Dim r As GridBuilderRect = Rows.Get(i)
		Dim vis As String = r.ZABDEF.Property("visibility").Value
		
		Dim isVis As Boolean = MaterialIcons.IsVisibleForMe(DrawGridType, vis) 
		
		If isVis = False And Main.ShowAll = False Then
			r.visible = False
			Continue
		End If
		r.visible = True

		r.Calculate(Left, LastRowTop, BlockWidth*12, BlockWidth, DrawGridType, Spacing)
		
		Dim RowLeft As Double = r.RowLeft(DrawGridType)
		Dim RowTop As Double = r.RowTop(DrawGridType)
		Dim RowWidth As Double = r.RowWidth(DrawGridType)
		Dim RowHeight As Double = r.RowHeight(DrawGridType)
		
		LastRowTop = RowTop + RowHeight + 10
		
		If CheckRow = i Then
			ABC.FillRoundRect(c,(RowLeft-Left/2),RowTop*Scale,(RowWidth+Left),RowHeight*Scale,10.0*Scale,DesTheme.GetPaint(DrawGridType,0, 76, isVis)) 										
		Else 
			ABC.FillRoundRect(c, (RowLeft-Left/2), RowTop*Scale, (RowWidth+Left),RowHeight*Scale,10.0*Scale,DesTheme.GetPaint(DrawGridType,0, 33, isVis))			
		End If	
		If IsMini = False Then
			If DesTheme.DarkTheme Then
				c.DrawText("R" & (i+1), RowLeft-Left/2+2, RowTop+18, fx.CreateFont("Arial",15,True, False), fx.Colors.ARGB(190,255,255,255), "LEFT")
			Else
				c.DrawText("R" & (i+1), RowLeft-Left/2+2, RowTop+18, fx.CreateFont("Arial",15,True, False), fx.Colors.ARGB(190,0,0,0), "LEFT")
			End If
				
			' toolbar 1
			ABC.FillRoundRect(c,RowLeft-Left/2, RowTop+30,25,25,25.0, fx.Colors.ARGB(255,0,0,0))
			c.DrawText("+", RowLeft-Left/2+6,RowTop+50, fx.CreateFont("Arial",20,True, False), fx.Colors.ARGB(255,255,255,255), "LEFT")
		
			' toolbar 2
			ABC.FillRoundRect(c,RowLeft-Left/2+RowWidth+Left-25, RowTop,25,25,25.0, fx.Colors.ARGB(255,0,0,0))
			c.DrawText("x", RowLeft-Left/2+RowWidth+Left-17, RowTop+17, fx.CreateFont("Arial",18,True, False), fx.Colors.ARGB(255,255,255,255), "LEFT")
			ABC.FillRoundRect(c,RowLeft-Left/2+RowWidth+Left-25, RowTop+30,25,25,25.0, fx.Colors.ARGB(255,0,0,0))
			c.DrawText("+", RowLeft-Left/2+RowWidth+Left-19, RowTop+50, fx.CreateFont("Arial",20,True, False), fx.Colors.ARGB(255,255,255,255), "LEFT")
		End If
				
		For j = 0 To r.Cells(DrawGridType).Size - 1
			Dim cell As GridBuilderRect = r.Cells(DrawGridType).Get(j) 
			Dim c2 As GridBuilderRect = r.Cells(2).Get(j) 			
			Dim cvis As String = c2.ZABDEF.Property("visibility").Value
			
			Dim iscVis As Boolean = True
			If isVis = False Or MaterialIcons.IsVisibleForMe(DrawGridType, cvis) = False Then
				iscVis = False
			End If
			If iscVis = False And Main.ShowAll = False Then
				Continue
			End If
			Dim dotlineAlpha As Int = 255
						
			ABC.FillRoundRect(c,cell.CellLeft, cell.CellTop * Scale,cell.Cellwidth,cell.CellHeight * Scale,10.0*Scale, DesTheme.GetPaint(DrawGridType,1, 255, iscVis))
			If cell.InitiatedBy <> DrawGridType Then
				ABC.FillRoundRectPattern(c,cell.CellLeft, cell.CellTop * Scale,cell.Cellwidth,cell.CellHeight * Scale,10.0*Scale, DesTheme.stripes)	
			End If
			If i = CheckRow And j = CheckCell Then
				If IsMini = False Then
					ABC.DrawRoundRect(c,cell.CellLeft-1, cell.CellTop-1,cell.Cellwidth,cell.CellHeight,10.0, fx.Colors.ARGB(255,255,255,dotlineAlpha),Array(6.0), 3.0)
				Else
					ABC.DrawRoundRect(c,cell.CellLeft, cell.CellTop*Scale,cell.Cellwidth,cell.CellHeight*Scale,10.0*Scale, fx.Colors.ARGB(255,255,255,dotlineAlpha),Array(1.0), 1.0)
				End If
			End If
			
			If IsMini = False Then
				' toolbar 1		
				ABC.FillRoundRect(c,cell.CellLeft-5, cell.CellTop+30,15,20,10.0, DesTheme.GetPaint(DrawGridType,2, 255, iscVis))
				c.DrawText("+", cell.CellLeft-3, cell.CellTop+46, fx.CreateFont("Arial",16,True, False), fx.Colors.ARGB(190,255,255,255), "LEFT")
				ABC.FillRoundRect(c,cell.CellLeft-5, cell.CellTop+60,15,cell.CellHeight-60,10.0, DesTheme.GetPaint(DrawGridType,2, 255, iscVis))
				c.DrawLine(cell.CellLeft, cell.CellTop + 70, cell.CellLeft, cell.CellTop + cell.CellHeight - 10, fx.Colors.ARGB(255,255,255,255),1)
				c.DrawLine(cell.CellLeft+4, cell.CellTop + 70, cell.CellLeft+4, cell.CellTop + cell.CellHeight - 10, fx.Colors.ARGB(255,255,255,255),1)
						
				' info
				c.DrawText("C" & (j+1), cell.CellLeft+2, cell.CellTop+14, fx.CreateFont("Arial",12,True, False), fx.Colors.ARGB(190,255,255,255), "LEFT")
			
				' toolbar 2
				ABC.FillRoundRect(c,cell.CellLeft+cell.Cellwidth-10, cell.CellTop,15,20,10.0, DesTheme.GetPaint(DrawGridType,2, 255, iscVis))
				c.DrawText("x", cell.CellLeft+cell.Cellwidth-7, cell.CellTop+14, fx.CreateFont("Arial",16,True, False), fx.Colors.ARGB(190,255,255,255), "LEFT")
				ABC.FillRoundRect(c,cell.CellLeft+cell.Cellwidth-10, cell.CellTop+30,15,20,10.0, DesTheme.GetPaint(DrawGridType,2, 255, iscVis))
				c.DrawText("+", cell.CellLeft+cell.Cellwidth-8, cell.CellTop+46, fx.CreateFont("Arial",16,True, False), fx.Colors.ARGB(190,255,255,255), "LEFT")
				ABC.FillRoundRect(c,cell.CellLeft+cell.Cellwidth-10, cell.CellTop+60,15,cell.CellHeight-60,10.0, DesTheme.GetPaint(DrawGridType,2, 255, iscVis))
				c.DrawLine(cell.CellLeft+cell.Cellwidth-4, cell.CellTop + 70, cell.CellLeft+cell.Cellwidth-4, cell.CellTop + cell.CellHeight - 10, fx.Colors.ARGB(255,255,255,255),1)
				c.DrawLine(cell.CellLeft+cell.Cellwidth, cell.CellTop + 70, cell.CellLeft+cell.Cellwidth, cell.CellTop + cell.CellHeight - 10, fx.Colors.ARGB(255,255,255,255),1)				
			End If
		Next
		If IsMini = False Then	
			RealLastMaxHeight = RowTop + RowHeight + 200
		End If
	Next
	
End Sub

public Sub FindActiveRow(x As Int, y As Int, GridType As Int) As GridBuilderRect
	For i = 0 To Rows.Size - 1
		Dim r As GridBuilderRect = Rows.Get(i)
		If r.InRect(x,y, GridType) Then		
			r.ClickedRowID = i
			r.IsOnRowClose = False
			r.IsOnRowAddBefore = False
			r.IsOnRowAddAfter = False
			
			Dim RowLeft As Double = r.RowLeft(GridType)
			Dim RowTop As Double = r.RowTop(GridType)
			Dim RowWidth As Double = r.RowWidth(GridType)
			Dim RowHeight As Double = r.RowHeight(GridType) 'ignore
			
			If x >= RowLeft-RealLeft/2 And x <= RowLeft-RealLeft/2+25 And y > RowTop + 30 And y <= RowTop + 55 Then
				r.IsOnRowAddBefore = True
				Return r
			End If
			If x >= RowLeft-RealLeft/2+RowWidth+RealLeft-25 And x <= RowLeft-RealLeft/2+RowWidth+RealLeft And y > RowTop + 30 And y <= RowTop + 55 Then
				r.IsOnRowAddAfter = True
				Return r
			End If
			If x >= RowLeft-RealLeft/2+RowWidth+RealLeft-25 And x <= RowLeft-RealLeft/2+RowWidth+RealLeft And y > RowTop And y <= RowTop + 25 Then
				r.IsOnRowClose = True
				Return r
			End If
			
			Return r
		End If
	Next
	Return Null
End Sub

public Sub FindActiveCell(x As Int, y As Int, row As GridBuilderRect, GridType As Int) As GridBuilderRect
	For i = 0 To row.Cells(GridType).Size - 1
		Dim c As GridBuilderRect = row.Cells(GridType).Get(i)
		If c.InRect(x,y,GridType) Then
			c.IsOnCellClose = False
			c.IsOnCellGrab = False
			c.IsOnCellComponent = Null
			c.isonCellResize = False
			c.IsOnCellAddBefore = False
			c.isOnCellAddafter = False
			c.ClickedCellID = i
			
			If x >= c.CellLeft - 10 And x <= c.CellLeft+10 And y > c.CellTop + 30 And y <= c.CellTop + 50 Then
				c.IsOnCellAddBefore = True
				Return c
			End If
			If x >= c.CellLeft-10 And x <= c.CellLeft+10 And y > c.CellTop And y > c.CellTop+60 Then
				c.IsOnCellGrab = True
				Return c
			End If
			
			If x >= c.CellLeft + c.CellWidth - 10 And x <= c.CellLeft + c.CellWidth + 10 And y <= c.CellTop + 20 Then
				c.IsOnCellClose = True
				Return c
			End If			
			If x >= c.CellLeft + c.CellWidth - 10 And x <= c.CellLeft + c.CellWidth + 10 And y > c.CellTop + 30 And y <= c.CellTop + 50 Then
				c.IsOnCellAddAfter = True
				Return c
			End If
			If x >= c.CellLeft + c.CellWidth - 10 And x <= c.CellLeft + c.CellWidth + 10 And y > c.CellTop + 60 Then
				c.isOnCellResize = True
				Return c
			End If
			' TODO is on component ?
			
			
			Return c
		End If
	Next
	Return Null
End Sub

public Sub RemoveRow(index As Int)
	Rows.RemoveAt(index)	
	ActiveCellID = 0
End Sub

public Sub InsertRow(index As Int)
	Dim r As GridBuilderRect
	r.Initialize(True, 0,0)
	r.AddCell(0,0,0,12,12,12,ActiveGridType)
	Rows.InsertAt(index, r)	
	ActiveCellID = 0
End Sub

public Sub AddRow()
	Dim r As GridBuilderRect
	r.Initialize(True, 0,0)
	r.AddCell(0,0,0,12,12,12,ActiveGridType)
	Rows.Add(r)	
	ActiveCellID = 0
End Sub

public Sub AddRowLoad()
	Dim r As GridBuilderRect
	r.Initialize(True, 0,0)
	
	Rows.Add(r)	
	ActiveCellID = 0
End Sub

public Sub RemoveCell(index As Int)
	Dim r As GridBuilderRect = Rows.Get(ActiveRowID)
	r.Cells(0).RemoveAt(index)
	r.Cells(1).RemoveAt(index)
	r.Cells(2).RemoveAt(index)
End Sub

public Sub InsertCellAfter(index As Int)
	Dim r As GridBuilderRect = Rows.Get(ActiveRowID)
	
	Dim cS As GridBuilderRect
	Dim cM As GridBuilderRect
	Dim cL As GridBuilderRect
	Select Case ActiveGridType
		Case 0
			cS.Initialize(False, 0, 1)	
			cM.Initialize(False, 0, 1)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 0
			cM.InitiatedBy = 0
			cL.InitiatedBy = 0
		Case 1
			cS.Initialize(False, 0, 12)	
			cM.Initialize(False, 0, 1)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 1
			cM.InitiatedBy = 1
			cL.InitiatedBy = 1			
		Case 2
			cS.Initialize(False, 0, 12)	
			cM.Initialize(False, 0, 12)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 2
			cM.InitiatedBy = 2
			cL.InitiatedBy = 2			
	End Select
	r.Cells(0).InsertAt(index, cS)
	r.Cells(1).InsertAt(index, cM)
	r.Cells(2).InsertAt(index, cL)
End Sub

public Sub InsertCellBefore(index As Int)
	Dim r As GridBuilderRect = Rows.Get(ActiveRowID)
	
	Dim acS As GridBuilderRect = r.Cells(0).Get(index)
	Dim acM As GridBuilderRect = r.Cells(1).Get(index)
	Dim acL As GridBuilderRect = r.Cells(2).Get(index)
		
	Dim cS As GridBuilderRect
	Dim cM As GridBuilderRect
	Dim cL As GridBuilderRect
	Select Case ActiveGridType
		Case 0
			cS.Initialize(False, acS.CellOffset, 1)	
			cM.Initialize(False, acM.CellOffset, 1)		
			cL.Initialize(False, acL.CellOffset, 1)	
			cS.InitiatedBy = 0
			cM.InitiatedBy = 0
			cL.InitiatedBy = 0			
		Case 1
			cS.Initialize(False, acS.CellOffset, 12)	
			cM.Initialize(False, acM.CellOffset, 1)		
			cL.Initialize(False, acL.CellOffset, 1)	
			cS.InitiatedBy = 1
			cM.InitiatedBy = 1
			cL.InitiatedBy = 1			
		Case 2
			cS.Initialize(False, acS.CellOffset, 12)	
			cM.Initialize(False, acM.CellOffset, 12)		
			cL.Initialize(False, acL.CellOffset, 1)	
			cS.InitiatedBy = 2
			cM.InitiatedBy = 2
			cL.InitiatedBy = 2			
	End Select
		
	r.Cells(0).InsertAt(index, cS)
	r.Cells(1).InsertAt(index, cM)
	r.Cells(2).InsertAt(index, cL)
	
	acS.CellOffset = 0
	acM.CellOffset = 0
	acL.CellOffset = 0
End Sub

public Sub AddCell()
	Dim r As GridBuilderRect = Rows.Get(ActiveRowID)
	Dim cS As GridBuilderRect
	Dim cM As GridBuilderRect
	Dim cL As GridBuilderRect
	Select Case ActiveGridType
		Case 0
			cS.Initialize(False, 0, 1)	
			cM.Initialize(False, 0, 1)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 0
			cM.InitiatedBy = 0
			cL.InitiatedBy = 0			
		Case 1
			cS.Initialize(False, 0, 12)	
			cM.Initialize(False, 0, 1)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 1
			cM.InitiatedBy = 1
			cL.InitiatedBy = 1			
		Case 2
			cS.Initialize(False, 0, 12)	
			cM.Initialize(False, 0, 12)		
			cL.Initialize(False, 0, 1)	
			cS.InitiatedBy = 2
			cM.InitiatedBy = 2
			cL.InitiatedBy = 2			
	End Select
	
	r.Cells(0).Add(cS)
	r.Cells(1).Add(cM)
	r.Cells(2).Add(cL)
End Sub

public Sub SetCellSize(newSize As Double)
	Dim acS As GridBuilderRect = ActiveCell(0)
	Dim acM As GridBuilderRect = ActiveCell(1)
	Dim acL As GridBuilderRect = ActiveCell(2)
	
	Select Case ActiveGridType
		Case 0
			acS.CellSize = newSize
			If acS.OrigCellSize <> newSize Then
				acS.InitiatedBy = 0
			End If			
			If acM.InitiatedBy <= ActiveGridType Then 
				acM.CellSize = newSize
			End If
			If acL.InitiatedBy <= ActiveGridType Then 
				acL.CellSize = newSize
			End If
		Case 1
			acM.CellSize = newSize
			If acM.OrigCellSize <> newSize Then
				acM.InitiatedBy = 1
			End If			
			If acL.InitiatedBy <= ActiveGridType Then 
				acL.CellSize = newSize
			End If
		Case 2
			acL.CellSize = newSize
			If acL.OrigCellSize <> newSize Then
				acL.InitiatedBy = 2	
			End If					
	End Select
End Sub

public Sub SetCellOffset(newOffset As Double)
	Dim acS As GridBuilderRect = ActiveCell(0)
	Dim acM As GridBuilderRect = ActiveCell(1)
	Dim acL As GridBuilderRect = ActiveCell(2)
	
	Select Case ActiveGridType
		Case 0
			acS.CellOffset = newOffset
			If acS.OrigCellOffset <> newOffset Then
				acS.InitiatedBy = 0
			End If			
			If acM.InitiatedBy <= ActiveGridType Then 
				acM.CellOffset = newOffset
			End If
			If acL.InitiatedBy <= ActiveGridType Then 
				acL.CellOffset = newOffset
			End If
		Case 1
			acM.CellOffset = newOffset
			If acM.OrigCellOffset <> newOffset Then
				acM.InitiatedBy = 1
			End If			
			If acL.InitiatedBy <= ActiveGridType Then  
				acL.CellOffset = newOffset
			End If
		Case 2
			acL.CellOffset = newOffset
			If acL.OrigCellOffset <> newOffset Then
				acL.InitiatedBy = 2	
			End If					
	End Select	
End Sub

public Sub SaveToDisk()
	' TODO
End Sub
