﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Public RowLeft(3) As Double
	Public RowTop(3) As Double
	Public RowWidth(3) As Double
	Public RowHeight(3) As Double
	
	Public CellLeft As Double
	Public CellTop As Double
	Public CellWidth As Double
	Public CellHeight As Double	
	
	Public Cells(3) As List

	Public CellSize As Double	
	Public CellOffset As Double
	Public OrigCellSize As Double	
	Public OrigCellOffset As Double
	
	Public IsRow As Boolean
	
	Public Components As List
	Public InitiatedBy As Int
	
	Public IsOnCellClose As Boolean = False
	Public IsOnCellGrab As Boolean = False
	Public IsOnCellComponent As GridBuilderRect	= Null
	Public IsOnCellResize As Boolean = False
	Public IsOnCellAddBefore As Boolean = False
	Public IsOnCellAddAfter As Boolean = False
	
	Public IsOnRowClose As Boolean = False
	Public IsOnRowAddBefore As Boolean = False
	Public IsOnRowAddAfter As Boolean = False
	
	Public ClickedRowID As Int
	Public ClickedCellID As Int
	
	Public ZABDEF As ZAbstractDesignerDefinition
	Public ABM As ABMaterial
	
	Public visible As Boolean = True
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(AsRow As Boolean, Offset As Int, Size As Int)
	If AsRow Then
		Cells(0).Initialize	
		Cells(1).Initialize
		Cells(2).Initialize
		IsRow = True
		ZABDEF = ABM.ZABDEFCreateRow
	Else
		CellOffset = Offset		
		CellSize = Size		
		Components.initialize	
		ZABDEF = ABM.ZABDEFCreateCell
	End If
End Sub

public Sub GetZABDEFRow(Prefix As String, rowId As Int) As ZAbstractDesignerDefinition
	Dim rID As ZAbstractDesignerProperty = ZABDEF.Property("id")
	rID.Value = Prefix & "R" & (rowId+1)
	Return ZABDEF
End Sub

public Sub GetZABDEFCell(prefix As String, rowId As Int, cellId As Int) As ZAbstractDesignerDefinition
	Dim cID As ZAbstractDesignerProperty = ZABDEF.Property("id")
	cID.Value = prefix & "R" & (rowId+1) & "C" & (cellId+1)
	Dim cCellInfo As ZAbstractDesignerProperty = ZABDEF.Property("cellinfo")
	cCellInfo.Value = "page.cell(" & (rowId + 1) & "," & (cellId+1) & ")"
	Return ZABDEF
End Sub

Public Sub InRect(x As Int, y As Int, GridType As Int) As Boolean
	If visible = False Then
		Return False
	End If
	If IsRow Then
		Return (x >= RowLeft(GridType)/2-10 And x <= RowLeft(GridType)/2 + RowWidth(GridType) + RowLeft(GridType)+20 And y >= RowTop(GridType) And y <= RowTop(GridType) + RowHeight(GridType))
	Else
		Return (x >= CellLeft-5 And x <= CellLeft + CellWidth+5 And y >= CellTop And y <= CellTop + CellHeight)
	End If
End Sub

public Sub Calculate(gLeft As Double, gTop As Double, gWidth As Double, BlockWidth As Double, GridType As Int, Spacing As Double)
	If IsRow Then
		RowLeft(GridType) = gLeft
		RowTop(GridType) = gTop
		RowWidth(GridType) = gWidth
		RowHeight(GridType) = CalculateWithComponentsTop
	Else
		CellLeft = gLeft
		CellTop = gTop
		CellWidth = gWidth
		CellHeight = CalculateWithComponentsTop
	End If
	
	If IsRow Then
		Private tmpCellLeft As Double
		Private CurrTop As Double
		CurrTop = RowTop(GridType)
		Dim LastCellHeight As Double
		Dim LastCellPos As Int
		Dim lastVisible As Int
		Dim currVisible As Int
		For i = 0 To Cells(GridType).Size - 1
			Dim c As GridBuilderRect = Cells(GridType).Get(i)
			Dim c2 As GridBuilderRect = Cells(2).Get(i)
			Dim cvis As String = c2.ZABDEF.Property("visibility").Value
			If MaterialIcons.IsVisibleForMe(GridType,cvis) = False And Main.ShowAll = False Then
				c.visible = False
			Else
				c.visible = True
				lastVisible = i
			End If
		Next		
		
		For i = 0 To Cells(GridType).Size - 1
			Dim c As GridBuilderRect = Cells(GridType).Get(i)
			If c.visible = False Then
				Continue
			End If	
			currVisible = i		
			If tmpCellLeft + c.CellOffset + c.CellSize <= 12 Then
				c.calculate(gLeft + (tmpCellLeft+c.CellOffset)*BlockWidth, CurrTop, BlockWidth * c.CellSize, BlockWidth, GridType, Spacing)				
			Else
				tmpCellLeft = 0
				LastCellPos = 0
				CurrTop = CurrTop + LastCellHeight
				c.calculate(gLeft + (tmpCellLeft+c.CellOffset)*BlockWidth, CurrTop, BlockWidth * c.CellSize, BlockWidth, GridType, Spacing)			
				
			End If
			LastCellHeight = c.CellHeight				
			LastCellPos = LastCellPos + c.CellOffset+ c.CellSize
			
			tmpCellLeft = tmpCellLeft + c.CellOffset + c.CellSize		
			c.CellWidth = c.CellWidth - Spacing
			c.CellTop = c.CellTop + 5
			c.Cellheight = c.Cellheight - 10		
			
		Next
		If currVisible = lastVisible Then
			CurrTop = CurrTop + LastCellHeight
		End If
		RowHeight(GridType) = CurrTop - RowTop(GridType)
		
		RowLeft(GridType) = RowLeft(GridType) - 15
		RowWidth(GridType) = RowWidth(GridType) + 15
	End If	
	
End Sub

Sub CalculateWithComponentsTop() As Double
	Dim h As Double
	If Not (IsRow) Then		
		For i = 0 To Components.Size - 1
			h = h + 25
		Next		
	End If
	If h < 110 Then
		h = 110
	End If
	Return h
End Sub

public Sub AddCell(offsetSmall As Int, offsetMedium As Int, offsetLarge As Int, sizeSmall As Int, sizeMedium As Int, sizeLarge As Int, Initializer As Int)
	Dim cS As GridBuilderRect
	cS.Initialize(False, offsetSmall, sizeSmall)
	If Initializer <= 0 Then
		cS.InitiatedBy = Initializer
	Else
		cS.InitiatedBy = 0
	End If
	Cells(0).Add(cS)
	Dim cM As GridBuilderRect
	cM.Initialize(False, offsetMedium, sizeMedium)
	If Initializer <= 1 Then
		cM.InitiatedBy = Initializer
	Else
		cM.InitiatedBy = 1
	End If
	Cells(1).Add(cM)
	Dim cL As GridBuilderRect
	cL.Initialize(False, offsetLarge, sizeLarge)
	If Initializer <= 2 Then
		cL.InitiatedBy = Initializer
	Else
		cL.InitiatedBy = 2
	End If
	Cells(2).Add(cL)
End Sub

public Sub AddCellLoad(offsetSmall As Int, offsetMedium As Int, offsetLarge As Int, sizeSmall As Int, sizeMedium As Int, sizeLarge As Int, InitializerS As Int, InitializerM As Int, InitializerL As Int)
	Dim cS As GridBuilderRect
	cS.Initialize(False, offsetSmall, sizeSmall)
	cS.InitiatedBy = InitializerS	
	Cells(0).Add(cS)
	
	Dim cM As GridBuilderRect
	cM.Initialize(False, offsetMedium, sizeMedium)
	cM.InitiatedBy = InitializerM
	Cells(1).Add(cM)
	
	Dim cL As GridBuilderRect
	cL.Initialize(False, offsetLarge, sizeLarge)
	cL.InitiatedBy = InitializerL
	Cells(2).Add(cL)
End Sub

public Sub Clone() As GridBuilderRect
	Dim c As GridBuilderRect
	c.Initialize(IsRow, CellOffset, CellSize)
	For i = 0 To 2
		c.RowLeft(i) = RowLeft(i)
		c.RowTop(i) = RowTop(i)
		c.RowWidth(i) = RowWidth(i)
		c.Rowheight(i) = RowHeight(i)
	Next
	c.CellLeft = CellLeft
	c.CellTop = CellTop
	c.CellWidth = CellWidth
	c.CellHeight = CellHeight
	c.InitiatedBy = InitiatedBy
	For i = 0 To Cells(0).Size - 1
		Dim cS As GridBuilderRect = Cells(0).Get(i)
		c.Cells(0).Add(cS.Clone)
		Dim cM As GridBuilderRect = Cells(1).Get(i)
		c.Cells(1).Add(cM.Clone)
		Dim cL As GridBuilderRect = Cells(2).Get(i)
		c.Cells(2).Add(cL.Clone)
	Next
	Return c
End Sub