﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Dim ListView1 As ListView
	Private Listwidth As Int
	Dim btnIcon As Button	
	Dim Properties As Map
	Public CurrentZABDEF As ZAbstractDesignerDefinition = Null
	Public ObjectType As String
End Sub

Public Sub Initialize(Obj As Pane, eventName As String, left As Double, top As Double, width As Double, height As Double)
	ListView1.Initialize(eventName)
	
	Obj.AddNode(ListView1, left, top, width, height)
	Listwidth = width - 35
	
	MaterialIcons.LoadIconsMat
	MaterialIcons.LoadIconsAwe
	MaterialIcons.LoadIconsGoo
	
	Properties.Initialize	
	Properties.Clear
End Sub

public Sub AddItem(Obj As Pane)
	ListView1.Items.Add(Obj)
End Sub

public Sub Clear() 
	Dim CurrentZABDEF As ZAbstractDesignerDefinition = Null
	Properties.Clear
	ListView1.Items.Clear
End Sub

public Sub CreateItem(itemType As Int, Depth As Int, ID As String, Name As String, NameStyle As String, Params As List) As AnchorPane
	Dim p As AnchorPane	
	p.Initialize(ID)
	p.Tag = itemType
	Dim itemHeight As Int = 26
		
	Select Case itemType
		Case 0 ' type label
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			Properties.Put(ID.ToLowerCase, lbl)
		Case 1 ' label
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			Properties.Put(ID.ToLowerCase, lbl)
		Case 2 ' label + input
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			Dim avWidth As Double = Listwidth - (Depth*10)
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			Dim inp As TextField
			inp.Initialize("")
			inp.Text = Params.get(0)
			p.AddNode(inp, Depth*10+avWidth/3,-2,avWidth/3*2-20, itemHeight-3)
			Properties.Put(ID.ToLowerCase, inp)
		Case 3 ' label + combo			
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			Dim avWidth As Double = Listwidth - (Depth*10)
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			Dim cmb As ComboBox
			cmb.Initialize("")
			Dim selIndex As Int
			For i = 1 To Params.Size - 1
				If Params.Get(0) = Params.Get(i) Then
					selIndex = i-1
				End If
				cmb.Items.Add(Params.Get(i))
			Next
			cmb.SelectedIndex = selIndex
			p.AddNode(cmb, Depth*10+avWidth/3,-4,avWidth/3*2-1, itemHeight-3)
			Properties.Put(ID.ToLowerCase, cmb)			
		Case 4 ' label + checkbox
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			Dim avWidth As Double = Listwidth - (Depth*10)
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			Dim chk As CheckBox
			chk.Initialize("")
			'chk.Text = Params.get(0)
			chk.Checked = Params.Get(0)
			p.AddNode(chk, Depth*10+avWidth/3,-2,avWidth/3*2-20, itemHeight-3)
			Properties.Put(ID.ToLowerCase, chk)
		Case 5 ' label + icon 
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = Name
			lbl.Style = NameStyle
			Dim avWidth As Double = Listwidth - (Depth*10)
			p.AddNode(lbl, Depth*10,-4,Listwidth-Depth*10, itemHeight)
			
			Dim iconFont As Font
			Dim iName As String = Params.Get(0)
			If iName.ToLowerCase.StartsWith("mdi") Then
				iconFont = fx.LoadFont(File.DirAssets,"Material-Design-Icons.ttf",20)
			else if iName.ToLowerCase.StartsWith("fa ") Or iName.ToLowerCase.StartsWith("fa-") Then
				iconFont = fx.LoadFont(File.DirAssets,"fontawesome-webfont.ttf",20)
			Else
				iconFont = fx.LoadFont(File.DirAssets,"MaterialIcons-Regular.ttf",20)
			End If
			 		
			Dim panel As AnchorPane
			panel.Initialize("")
			panel.Style = "-fx-background-color:transparent;"
			Dim icon As Label
			icon.Initialize("")
			If Params.Get(0) <> "" Then
				icon.Text = MaterialIcons.GetValue(Params.Get(0))
			End If			
			icon.Font = iconFont
			icon.Style = "-fx-background-color:transparent;-fx-text-fill: " & DesTheme.PropForeColor & ";"
			Dim iconName As Label
			iconName.Initialize("")
			iconName.Text = Params.Get(0)
			iconName.Style = "-fx-background-color:transparent;-fx-text-fill: " & DesTheme.PropForeColor & ";"
			panel.AddNode(icon, 0,0,31,itemHeight-3)
			panel.AddNode(iconName, 35,0,avWidth/3*2-75,itemHeight-3)	
			btnIcon.Initialize("btnIcon")
			btnIcon.Text = "..."
			btnIcon.Tag = ListView1.Items.Size
			panel.AddNode(btnIcon, avWidth/3*2-25, 0, 22, itemHeight-4)
			p.AddNode(panel, Depth*10+avWidth/3,-2,avWidth/3*2-20, itemHeight-3)
			Properties.Put(ID.ToLowerCase, iconName)
	End Select
	
	Return p
End Sub

Public Sub SaveProperties(GridBuild As GridBuilder)
	If CurrentZABDEF <> Null And Properties.IsInitialized Then
		Dim Groups As List
		
		Select Case ObjectType.ToLowerCase
			Case "cell"
				Dim acS As GridBuilderRect = GridBuild.ActiveCell(0)
				Dim acM As GridBuilderRect = GridBuild.ActiveCell(1)
				Dim acL As GridBuilderRect = GridBuild.ActiveCell(2)
				Groups = acS.ZABDEF.Groups(1)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acS.ZABDEF.Properties(group, 1).Values		
						If Prop.Name.EqualsIgnoreCase("fixed height") Then
							i = i					
						End If						
						Select Case Prop.PropType
							Case "boolean"
								Dim chk As CheckBox = Properties.Get(Prop.Name.ToLowerCase)
								Prop.Value = chk.Checked
							Case "int"
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valInt As Int = ZI0(inp.Text)
								Prop.Value = valInt
							Case "double"							
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valDbl As Double = ZD0(inp.Text)
								Prop.Value = valDbl
							Case "string"
								If Prop.Name.EqualsIgnoreCase("icon name") Then		
									Dim iconName As Label = Properties.Get(Prop.Name.ToLowerCase)
									Prop.Value = iconName.Text
								Else
									If Prop.Selections.Size = 0 Then								
										Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = inp.Text
									Else
										Dim cmb As ComboBox = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = cmb.Value										
									End If
								End If
						End Select
					Next
				Next	
				Groups = acM.ZABDEF.Groups(1)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acM.ZABDEF.Properties(group, 1).Values								
						Select Case Prop.PropType
							Case "boolean"
								Dim chk As CheckBox = Properties.Get(Prop.Name.ToLowerCase)
								Prop.Value = chk.Checked
							Case "int"
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valInt As Int = ZI0(inp.Text)
								Prop.Value = valInt
							Case "double"							
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valDbl As Double = ZD0(inp.Text)
								Prop.Value = valDbl
							Case "string"
								If Prop.Name.EqualsIgnoreCase("icon name") Then		
									Dim iconName As Label = Properties.Get(Prop.Name.ToLowerCase)
									Prop.Value = iconName.Text
								Else
									If Prop.Selections.Size = 0 Then
										Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = inp.Text
									Else
										Dim cmb As ComboBox = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = cmb.Value										
									End If
								End If
						End Select
					Next
				Next	
				Groups = acL.ZABDEF.Groups(1)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acL.ZABDEF.Properties(group, 1).Values								
						Select Case Prop.PropType
							Case "boolean"
								Dim chk As CheckBox = Properties.Get(Prop.Name.ToLowerCase)
								Prop.Value = chk.Checked
							Case "int"
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valInt As Int = ZI0(inp.Text)
								Prop.Value = valInt
							Case "double"							
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valDbl As Double = ZD0(inp.Text)
								Prop.Value = valDbl
							Case "string"
								If Prop.Name.EqualsIgnoreCase("icon name") Then		
									Dim iconName As Label = Properties.Get(Prop.Name.ToLowerCase)
									Prop.Value = iconName.Text
								Else
									If Prop.Selections.Size = 0 Then
										Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = inp.Text
									Else
										Dim cmb As ComboBox = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = cmb.Value										
									End If
								End If
						End Select
					Next
				Next	
				Groups = acS.ZABDEF.Groups(2)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acS.ZABDEF.Properties(group, 2).Values						
						Select Case Prop.Name.ToLowerCase
							Case "offsetsmall"
								Dim valInt As Int = ZI0(acS.CellOffset)
								Prop.Value = valInt
							Case "offsetmedium"
								Dim valInt As Int = ZI0(acM.CellOffset)
								Prop.Value = valInt
							Case "offsetlarge"
								Dim valInt As Int = ZI0(acL.CellOffset)
								Prop.Value = valInt
							Case "sizesmall"
								Dim valInt As Int = ZI0(acS.CellSize)
								Prop.Value = valInt
							Case "sizemedium"
								Dim valInt As Int = ZI0(acM.CellSize)
								Prop.Value = valInt
							Case "sizelarge"
								Dim valInt As Int = ZI0(acL.CellSize)
								Prop.Value = valInt
						End Select
					Next
				Next
				Groups = acM.ZABDEF.Groups(2)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acM.ZABDEF.Properties(group, 2).Values						
						Select Case Prop.Name.ToLowerCase
							Case "offsetsmall"
								Dim valInt As Int = ZI0(acS.CellOffset)
								Prop.Value = valInt
							Case "offsetmedium"
								Dim valInt As Int = ZI0(acM.CellOffset)
								Prop.Value = valInt
							Case "offsetlarge"
								Dim valInt As Int = ZI0(acL.CellOffset)
								Prop.Value = valInt
							Case "sizesmall"
								Dim valInt As Int = ZI0(acS.CellSize)
								Prop.Value = valInt
							Case "sizemedium"
								Dim valInt As Int = ZI0(acM.CellSize)
								Prop.Value = valInt
							Case "sizelarge"
								Dim valInt As Int = ZI0(acL.CellSize)
								Prop.Value = valInt
						End Select
					Next
				Next
				Groups = acL.ZABDEF.Groups(2)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In acL.ZABDEF.Properties(group, 2).Values						
						Select Case Prop.Name.ToLowerCase
							Case "offsetsmall"
								Dim valInt As Int = ZI0(acS.CellOffset)
								Prop.Value = valInt
							Case "offsetmedium"
								Dim valInt As Int = ZI0(acM.CellOffset)
								Prop.Value = valInt
							Case "offsetlarge"
								Dim valInt As Int = ZI0(acL.CellOffset)
								Prop.Value = valInt
							Case "sizesmall"
								Dim valInt As Int = ZI0(acS.CellSize)
								Prop.Value = valInt
							Case "sizemedium"
								Dim valInt As Int = ZI0(acM.CellSize)
								Prop.Value = valInt
							Case "sizelarge"
								Dim valInt As Int = ZI0(acL.CellSize)
								Prop.Value = valInt
						End Select
					Next
				Next	
				ObjectType = ObjectType
			Case Else			
				Groups = CurrentZABDEF.Groups( 1)
				For i = 0 To Groups.Size - 1
					Dim group As Int = Groups.Get(i)
					For Each Prop As ZAbstractDesignerProperty In CurrentZABDEF.Properties(group, 1).Values			
						Select Case Prop.PropType
							Case "boolean"
								Dim chk As CheckBox = Properties.Get(Prop.Name.ToLowerCase)
								Prop.Value = chk.Checked
							Case "int"
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valInt As Int = ZI0(inp.Text)
								Prop.Value = valInt
							Case "double"							
								Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
								Dim valDbl As Double = ZD0(inp.text)
								Prop.Value = valDbl
							Case "string"
								If Prop.Name.EqualsIgnoreCase("icon name") Then		
									Dim iconName As Label = Properties.Get(Prop.Name.ToLowerCase)
									Prop.Value = iconName.Text
								Else
									If Prop.Selections.Size = 0 Then
										Dim inp As TextField = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = inp.Text
									Else
										Dim cmb As ComboBox = Properties.Get(Prop.Name.ToLowerCase)
										Prop.Value = cmb.Value
									End If
								End If
						End Select
					Next
				Next	
		End Select
		
	End If
End Sub

private Sub ZI0(s As String) As Int
	If s = "" Then Return 0
	Return s
End Sub

private Sub ZD0(s As String) As Double
	If s = "" Then Return 0
	Return s
End Sub

public Sub LoadProperties(ZABDEF As ZAbstractDesignerDefinition, objType As String, Title As String)
	CurrentZABDEF = ZABDEF
	Properties.Clear
	ListView1.Items.Clear
	Dim Groups As List
	ObjectType = objType
	Groups = ZABDEF.Groups(1)
	AddItem(CreateItem(0,0, "0", Title, "-fx-font-weight: bold;-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 12pt; -fx-text-fill: " & DesTheme.TitleColor & "; ", Array As String()))		
	For i = 0 To Groups.Size - 1
		Dim group As Int = Groups.Get(i)
		Select Case group
			Case 0:
				AddItem(CreateItem(1,0, "0", "Main Properties", "-fx-font-weight: bold;-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 9pt", Array As String()))
			Case 1:
				AddItem(CreateItem(1,0, "0", "Visual Properties", "-fx-font-weight: bold;-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 9pt", Array As String()))
			Case 2:
				AddItem(CreateItem(1,0, "0", "Positional Properties", "-fx-font-weight: bold;-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 9pt", Array As String()))
			Case 3:
				AddItem(CreateItem(1,0, "0", "Other", "-fx-font-weight: bold;-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 9pt", Array As String()))
		End Select
		For Each Prop As ZAbstractDesignerProperty In ZABDEF.Properties(group, 1).Values		
			Select Case Prop.PropType
				Case "boolean"
					AddItem(CreateItem(4,1, Prop.Name, "  " & Prop.Name, "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Array As String(Prop.Value)))
				Case "int"
					AddItem(CreateItem(2,1, Prop.Name, "  " & Prop.Name, "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Array As String(Prop.Value)))
				Case "double"							
					AddItem(CreateItem(2,1, Prop.Name, "  " & Prop.Name, "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Array As String(Prop.Value)))
				Case "string"
					If Prop.Name.EqualsIgnoreCase("icon name") Then		
						AddItem(CreateItem(5,1, Prop.Name, "  " & "Icon", "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Array As String(Prop.Value)))
					Else						
						If Prop.Selections.Size = 0 Then								
							AddItem(CreateItem(2,1, Prop.Name, "  " & Prop.Name, "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Array As String(Prop.Value)))
						Else
							AddItem(CreateItem(3,1, Prop.Name, "  " & Prop.Name, "-fx-background-color:" & DesTheme.PropBackColor & ";-fx-text-fill: " & DesTheme.PropForeColor & ";-fx-font-size: 8pt", Prop.Selections))							
						End If
					End If
			End Select
		Next
	Next		
End Sub

Sub btnIcon_MouseClicked (EventData As MouseEvent)
	Dim btnIcon As Button = Sender
	CallSub2(Main, "OpenIconsSelect", btnIcon.Tag)
End Sub

public Sub UpdateProperty(index As Int, value As Object)
	Dim p As AnchorPane	= ListView1.Items.Get(index)
	Select Case p.Tag
		Case 0
			
		Case 1
			
		Case 2
			
		Case 3
			
		Case 4
			
		Case 5
			Dim panel As AnchorPane = p.GetNode(1)
			Dim icon As Label = panel.GetNode(0)
			Dim iconFont As Font
			Dim iName As String = value
			If iName.ToLowerCase.StartsWith("mdi") Then
				iconFont = fx.LoadFont(File.DirAssets,"Material-Design-Icons.ttf",20)
			else if iName.ToLowerCase.StartsWith("fa ") Or iName.ToLowerCase.StartsWith("fa-") Then
				iconFont = fx.LoadFont(File.DirAssets,"fontawesome-webfont.ttf",20)
			Else
				iconFont = fx.LoadFont(File.DirAssets,"MaterialIcons-Regular.ttf",20)
			End If
			icon.Font = iconFont
			icon.Text = MaterialIcons.GetValue(value)
			Dim iconName As Label = panel.GetNode(1)
			iconName.Text = value
	End Select
	
End Sub

